//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.3.2 
// See <a href="https://javaee.github.io/jaxb-v2/">https://javaee.github.io/jaxb-v2/</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2020.02.07 at 08:51:11 PM CET 
//


package org.tdwg.abcd3.zoology;

import java.util.ArrayList;
import java.util.List;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlAttribute;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlSchemaType;
import jakarta.xml.bind.annotation.XmlType;
import jakarta.xml.bind.annotation.adapters.NormalizedStringAdapter;
import jakarta.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * Specimen preparation details.
 * 
 * <p>Java class for Preparation complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="Preparation"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="PreparationType" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}StringL" minOccurs="0"/&gt;
 *         &lt;element name="PreparationAgents" minOccurs="0"&gt;
 *           &lt;complexType&gt;
 *             &lt;complexContent&gt;
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *                 &lt;sequence&gt;
 *                   &lt;element name="PreparationAgent" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}String255" maxOccurs="unbounded"/&gt;
 *                 &lt;/sequence&gt;
 *                 &lt;attribute name="sequence" type="{http://www.w3.org/2001/XMLSchema}int" /&gt;
 *               &lt;/restriction&gt;
 *             &lt;/complexContent&gt;
 *           &lt;/complexType&gt;
 *         &lt;/element&gt;
 *         &lt;element name="PreparationDate" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}String" minOccurs="0"/&gt;
 *       &lt;/sequence&gt;
 *       &lt;attribute name="sequence" type="{http://www.w3.org/2001/XMLSchema}int" /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Preparation", propOrder = {
    "preparationType",
    "preparationAgents",
    "preparationDate"
})
public class Preparation {

    @XmlElement(name = "PreparationType")
    protected StringL preparationType;
    @XmlElement(name = "PreparationAgents")
    protected Preparation.PreparationAgents preparationAgents;
    @XmlElement(name = "PreparationDate")
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    @XmlSchemaType(name = "normalizedString")
    protected String preparationDate;
    @XmlAttribute(name = "sequence")
    protected Integer sequence;

    /**
     * Gets the value of the preparationType property.
     * 
     * @return
     *     possible object is
     *     {@link StringL }
     *     
     */
    public StringL getPreparationType() {
        return preparationType;
    }

    /**
     * Sets the value of the preparationType property.
     * 
     * @param value
     *     allowed object is
     *     {@link StringL }
     *     
     */
    public void setPreparationType(StringL value) {
        this.preparationType = value;
    }

    /**
     * Gets the value of the preparationAgents property.
     * 
     * @return
     *     possible object is
     *     {@link Preparation.PreparationAgents }
     *     
     */
    public Preparation.PreparationAgents getPreparationAgents() {
        return preparationAgents;
    }

    /**
     * Sets the value of the preparationAgents property.
     * 
     * @param value
     *     allowed object is
     *     {@link Preparation.PreparationAgents }
     *     
     */
    public void setPreparationAgents(Preparation.PreparationAgents value) {
        this.preparationAgents = value;
    }

    /**
     * Gets the value of the preparationDate property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getPreparationDate() {
        return preparationDate;
    }

    /**
     * Sets the value of the preparationDate property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setPreparationDate(String value) {
        this.preparationDate = value;
    }

    /**
     * Gets the value of the sequence property.
     * 
     * @return
     *     possible object is
     *     {@link Integer }
     *     
     */
    public Integer getSequence() {
        return sequence;
    }

    /**
     * Sets the value of the sequence property.
     * 
     * @param value
     *     allowed object is
     *     {@link Integer }
     *     
     */
    public void setSequence(Integer value) {
        this.sequence = value;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType&gt;
     *   &lt;complexContent&gt;
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
     *       &lt;sequence&gt;
     *         &lt;element name="PreparationAgent" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}String255" maxOccurs="unbounded"/&gt;
     *       &lt;/sequence&gt;
     *       &lt;attribute name="sequence" type="{http://www.w3.org/2001/XMLSchema}int" /&gt;
     *     &lt;/restriction&gt;
     *   &lt;/complexContent&gt;
     * &lt;/complexType&gt;
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "preparationAgent"
    })
    public static class PreparationAgents {

        @XmlElement(name = "PreparationAgent", required = true)
        @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
        @XmlSchemaType(name = "normalizedString")
        protected List<String> preparationAgent;
        @XmlAttribute(name = "sequence")
        protected Integer sequence;

        /**
         * Gets the value of the preparationAgent property.
         * 
         * <p>
         * This accessor method returns a reference to the live list,
         * not a snapshot. Therefore any modification you make to the
         * returned list will be present inside the JAXB object.
         * This is why there is not a <CODE>set</CODE> method for the preparationAgent property.
         * 
         * <p>
         * For example, to add a new item, do as follows:
         * <pre>
         *    getPreparationAgent().add(newItem);
         * </pre>
         * 
         * 
         * <p>
         * Objects of the following type(s) are allowed in the list
         * {@link String }
         * 
         * 
         */
        public List<String> getPreparationAgent() {
            if (preparationAgent == null) {
                preparationAgent = new ArrayList<String>();
            }
            return this.preparationAgent;
        }

        /**
         * Gets the value of the sequence property.
         * 
         * @return
         *     possible object is
         *     {@link Integer }
         *     
         */
        public Integer getSequence() {
            return sequence;
        }

        /**
         * Sets the value of the sequence property.
         * 
         * @param value
         *     allowed object is
         *     {@link Integer }
         *     
         */
        public void setSequence(Integer value) {
            this.sequence = value;
        }

    }

}
